;
; Copyright 2005, 2006 University of Leiden.
;
; This file is part of MIA+EWS.
;
; MIA+EWS is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; MIA+EWS is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with MIA; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
PRO spPhotoChop__define
p={ spPhotoChop, $
photoWaveNo:PTR_NEW(), $
photoMaskFile:'', $
maskData:PTR_NEW(), $
AChopFile:'', $
BChopFile:'', $
AChopData:PTR_NEW(), $
BChopData:PTR_NEW(), $
ABChopData:PTR_NEW(), $
maskFlux:REPLICATE(PTR_NEW(),3,2), $ ;A,B,AB for 1,2 $
totalFlux:REPLICATE(PTR_NEW(),3,2) $ ;A,B,AB for 1,2 $
}
RETURN
END

PRO spPhotoChop::save, file
   if (PTR_VALID(self.photoWaveNo)) then photoWaveNo=*self.photoWaveNo $
     else photoWaveNo = 0
  photoMaskFile = self.photoMaskFile
   if (PTR_VALID(self.maskData)) then maskData = *self.maskData $
      else maskData = 0
   AChopFile = self.AChopFile
   BChopFile = self.BChopFile
   if (PTR_VALID(self.AChopData)) then AChopData = *self.AChopData $
      else aChopData = 0
   if (PTR_VALID(self.BChopData)) then BChopData = *self.BChopData $
      else BChopData = 0
   if (PTR_VALID(self.ABChopData)) then ABChopData = *self.ABChopData $
      else ABChopData = 0
   if (PTR_VALID(self.maskFlux[0,0])) then begin
      maskflux00 = *self.maskFlux[0,0]
      maskflux10 = *self.maskFlux[1,0]
      maskflux20 = *self.maskFlux[2,0]
      maskflux01 = *self.maskFlux[0,1]
      maskflux11 = *self.maskFlux[1,1]
      maskflux21 = *self.maskFlux[2,1]
   endif
   if (PTR_VALID(self.totalFlux[0,0])) then begin
      totalflux00 = *self.totalFlux[0,0]
      totalflux10 = *self.totalFlux[1,0]
      totalflux20 = *self.totalFlux[2,0]
      totalflux01 = *self.totalFlux[0,1]
      totalflux11 = *self.totalFlux[1,1]
      totalflux21 = *self.totalFlux[2,1]
   endif
   SAVE,file=file+'_spPhotoChop', photoWaveNo, photoMaskFile, $
      maskData, aChopFile, BChopFile, AChopData, BChopData, ABChopData, $
      maskflux00, maskflux10, maskflux20, maskflux01, maskflux11, $
      maskflux21, $
      totalflux00, totalflux10, totalflux20, totalflux01, totalflux11, $
      totalflux21
RETURN
END

PRO spPhotoChop::getData, file, gui=gui, after=after, before=before
;********************************************************
;#procedure#
;getData
;#description#
;get files with photometric chopped data
;#call#
;chopObj->getData, fileNames
;chopObj->getData, /gui
;chopObj->getData, dir, /gui
;#inputs#
;\anArg{file}{strarr[2]}{file names of A and B photometry data}
;\anArg{file}{strarr}{directory for file gui}
;\anArg{gui}{flag}{use gui to find files}
;#end_procedure#
;********************************************************
   if (KEYWORD_SET(gui)) then begin
      if (N_PARAMS() LT 1) then file = '.'
      photoFiles = midigui(dir=file)
   endif else photoFiles = file
   if (N_ELEMENTS(photoFiles) NE 2) then begin
      print,'I need two files, A and B to do chopping photometry'
      RETURN
   endif
   self.AChopFile = photoFiles[0]
   self.BChopFile = photoFiles[1]
   PTR_FREE, self.AChopData
   PTR_FREE, self.BChopData
   PTR_FREE, self.ABChopData
   print,' Reading Chop Photometry Data from ',self.AChopFile
   print,' Reading Chop Photometry Data from ',self.BChopFile
   data = midiChopImage(self.AChopFile,after=after,before=before)
   PTR_FREE, self.photoWaveNo
   self.photoWaveNo = PTR_NEW(oirGetWaveno(photoFiles[0]))
   midigetINS, self.AChopFile, dit=dit ; exposure time
   data[0].DATA1 = (data[0].DATA1 - data[1].DATA1)/dit
   data[0].DATA2 = (data[0].DATA2 - data[1].DATA2)/dit
   self.AChopData = PTR_NEW(data[0])
   data = midiChopImage(self.BChopFile,after=after,before=before)
   data[0].DATA1 = (data[0].DATA1 - data[1].DATA1)/dit
   data[0].DATA2 = (data[0].DATA2 - data[1].DATA2)/dit
   self.BChopData = PTR_NEW(data[0])
   self.ABChopData = PTR_NEW(data[0])
   (*self.ABChopData).DATA1 = (*self.AChopData).DATA1 * (*self.BChopData).DATA1 
   (*self.ABChopData).DATA2 = (*self.AChopData).DATA2 * (*self.BChopData).DATA2
   if (NOT PTR_VALID(self.maskData)) then print,'NO mask data yet available' else begin
      for i=0,2 do for j=0,1 do PTR_FREE,self.maskFlux[i,j]
      self.maskFlux[0,0] = PTR_NEW($
         TOTAL((*self.maskData).DATA1 * (*self.AChopData).DATA1,2))
      self.maskFlux[1,0] = PTR_NEW($
         TOTAL((*self.maskData).DATA1 * (*self.BChopData).DATA1,2))
      self.maskFlux[2,0] = PTR_NEW($
         TOTAL((*self.maskData).DATA1 * SQRT((*self.ABChopData).DATA1> 0.),2))
      self.maskFlux[0,1] = PTR_NEW($
         TOTAL((*self.maskData).DATA2 * (*self.AChopData).DATA2,2))
      self.maskFlux[1,1] = PTR_NEW($
         TOTAL((*self.maskData).DATA2 * (*self.BChopData).DATA2,2))
      self.maskFlux[2,1] = PTR_NEW($
         TOTAL((*self.maskData).DATA2 * SQRT((*self.ABChopData).DATA2 > 0.),2))
   endelse
   for i=0,2 do for j=0,1 do PTR_FREE,self.totalFlux[i,j]
   self.totalFlux[0,0] = PTR_NEW(TOTAL((*self.AChopData).DATA1,2))
   self.totalFlux[1,0] = PTR_NEW(TOTAL((*self.BChopData).DATA1,2))
   self.totalFlux[2,0] = PTR_NEW(TOTAL(SQRT((*self.ABChopData).DATA1> 0.),2))
   self.totalFlux[0,1] = PTR_NEW(TOTAL((*self.AChopData).DATA2,2))
   self.totalFlux[1,1] = PTR_NEW(TOTAL((*self.BChopData).DATA2,2))
   self.totalFlux[2,1] = PTR_NEW(TOTAL(SQRT((*self.ABChopData).DATA2 > 0.),2))
RETURN
END

FUNCTION spPhotoChop::init, file, maskgui=maskgui, fitsFile=fitsFile, gui=gui, $
   after=after, before=before, restore=restore
;
if (NOT KEYWORD_SET(restore)) then begin
   if (NOT KEYWORD_SET(maskgui)) then begin
      self.photoMaskFile = file
      self.maskData = PTR_NEW(oirGetData(file))
   endif else begin
      if (N_PARAMS() LT 1) then maskdir = '.' else maskdir=file
      f = DIALOG_PICKFILE(title='Pick Mask File', path=maskdir)
      self.photoMaskFile = f
      if (f NE '') then self.maskData = PTR_NEW(oirGetData(self.photoMaskFile))
   endelse
   if (KEYWORD_SET(fitsFile) OR KEYWORD_SET(gui)) then begin
      if (KEYWORD_SET(gui)) then fitsFile = midiGui()
      if (N_ELEMENTS(fitsFile) NE 2) then begin
         print,'I need exactly two files for spectrophotometry'
         RETURN,1
      endif
      self->getData, fitsFile
   endif
endif else begin
   RESTORE,file=file+'_spPhotoChop'
   self.photoWaveNo=PTR_NEW(photoWaveNo )
   self.photoMaskFile = photoMaskFile
   self.maskData = PTR_NEW(self.maskData)
   self.AChopFile = AChopFile
   self.BChopFile = BChopFile
   self.AChopData = PTR_NEW(AChopData)
   self.BChopData = PTR_NEW(BChopData)
   self.ABChopData = PTR_NEW(ABChopData)
   self.maskFlux[0,0]=PTR_NEW(maskflux00)
   self.maskFlux[1,0]=PTR_NEW(maskflux10)
   self.maskFlux[2,0]=PTR_NEW(maskflux20)
   self.maskFlux[0,1]=PTR_NEW(maskflux01)
   self.maskFlux[1,1]=PTR_NEW(maskflux11)
   self.maskFlux[2,1]=PTR_NEW(maskflux21)
   self.totalFlux[0,0]=PTR_NEW(totalflux00)
   self.totalFlux[1,0]=PTR_NEW(totalflux10)
   self.totalFlux[2,0]=PTR_NEW(totalflux20)
   self.totalFlux[0,1]=PTR_NEW(totalflux01)
   self.totalFlux[1,1]=PTR_NEW(totalflux11)
   self.totalFlux[2,1]=PTR_NEW(totalflux21)
endelse
RETURN,1
END

PRO spPhotoChop::cleanup
   PTR_FREE,self.AChopData
   PTR_FREE,self.BChopData
   PTR_FREE,self.ABChopData
   PTR_FREE,self.photoWaveNo
   for i=0,2 do for j=0,1 do PTR_FREE,self.maskFlux[i,j]
   for i=0,2 do for j=0,1 do PTR_FREE,self.totalFlux[i,j]
RETURN
END


FUNCTION spPhotoChop::deSkyImage, image, mask, maskFlux, totalFlux, sky, skyErr, $
   maxR=maxR, tol=tol
;********************************************************
;#function#
;deSkyImage
;#description#
;estimate sky from 1 image and remove it
;#call#
;sky = fringeLabObj->findSky(image, mask, maskFlux, totalFlux, sky, skyErr, maxR=maxR, tol=tol)
;#inputs#
;\anArg{image}{fltarr}{input image}
;\anArg{mask}{fltarr}{array of same dim as image, weights per pixel}
;\anArg{maxR}{flt}{look out to maxR pixels; if haven't reached sky yet; sky=0}
;\anArg{tol}{flt}{look out until fract. change in sky contrib. to flux < tol ;def=.01}
;#outputs#
;\anArg{maskFlux}{flt}{estimated flux under mask}
;\anArg{totalFlux}{flt}{estimated total flux to effective maxR}
;\anArg{sky}{flt}{estimated sky per pixel}
;\anArg{skyerr}{flt}{estimated rms sky per pixel}
;#returns#
;\anArg{-}{fltarr}{image - sky}
;#end_function#
;********************************************************
   if (NOT KEYWORD_SET(tol)) then tol = 0.01
   if (NOT KEYWORD_SET(maxR)) then maxR = 15
; dimensions of image array and pos of max.
   sImage = SIZE(image, /dimension)
   nX = sImage[0]
   nY = sImage[1]
   image1 = TOTAL(image,1)
;   m = MAX(image1,y0)
   y0 = pk(findgen(nY), image1)
; array of distance from maximum in pixels
   rr = ABS(findgen(nY) - y0)
   mR = maxR < y0 < (nY-y0) ; max usable radius
; arrays of mean and rms sky estimate in circular aprs.
   skyFlux  = fltarr(mR)
   skyFlux2 = fltarr(mR)
   for i=1, mR-1 do begin 
      s=WHERE((rr ge (i-1)) AND (rr le (i+1)))
      m = moment(image1[s])
      skyFlux[i]  = m[0]
      skyFlux2[i] = m[1]
   endfor
; derivative of change
  dS = skyFlux - shift(skyFlux,1)
  dS[0] = -1.e9  ; large negative number
  flux0 = TOTAL(mask*image)
  tMask = TOTAL(mask)
; where change in sky estimate is < tol * flux
  sMin = 2+MIN(WHERE(dS[2:*] GT (-tol * ABS(flux0/tMask)), nWhere))
  if ((nWhere EQ 0) OR (sMin LT 2)) then sMin = mR-1
  dR = ROUND(rr[sMin])
  sky = (TOTAL(image[*,y0+dR-1+indgen(3)],2)+ TOTAL(image[*,y0-dR-1+indgen(3)],2))/6.
; skyErr = SQRT(TOTAL(skyFlux2[sMin],1)>0)
  output = image 
  for i=0,nY-1 do output(*,i) = output(*,i) - sky
  maskFlux = TOTAL(mask * output,2)
  s=WHERE(rr le sMin)
  totalFlux = TOTAL(output(*,s),2)
RETURN, output
END 

PRO spPhotoChop::deSky, tol = tol
;********************************************************
;#procedure#
;deSky
;#description#
;remove sky estimates from internal photom. data
;#call#
;fringeLabObj->deSky
;#end_procedure#
;********************************************************
   if (NOT PTR_VALID(self.maskData)) then begin
      print,'I need mask file for my sky removal technique'
      RETURN
   endif
   for i=0,2 do for j=0,1 do begin 
      PTR_FREE, self.maskFlux[i,j]
      PTR_FREE, self.totalFlux[i,j]
   endfor
   if (PTR_VALID(self.AChopData)) then begin 
      (*self.AChopData).DATA1 = $
         self->deSkyImage((*self.AChopData).DATA1, (*self.maskData).DATA1, m,t,tol=tol)
      self.maskFlux[0,0]  = PTR_NEW(m)
      self.totalFlux[0,0] = PTR_NEW(t)
   endif
   if (PTR_VALID(self.AChopData)) then begin 
      (*self.AChopData).DATA2= $
         self->deSkyImage((*self.AChopData).DATA2, (*self.maskData).DATA2, m,t,tol=tol)
      self.maskFlux[0,1]  = PTR_NEW(m)
      self.totalFlux[0,1] = PTR_NEW(t)
   endif
   if (PTR_VALID(self.BChopData)) then begin 
      (*self.BChopData).DATA1 = $
         self->deSkyImage((*self.BChopData).DATA1, (*self.maskData).DATA1,m,t,tol=tol)
      self.maskFlux[1,0]  = PTR_NEW(m)
      self.totalFlux[1,0] = PTR_NEW(t)
   endif
   if (PTR_VALID(self.BChopData)) then begin 
      (*self.BChopData).DATA2= $
         self->deSkyImage((*self.BChopData).DATA2, (*self.maskData).DATA2,m,t,tol=tol)
      self.maskFlux[1,1]  = PTR_NEW(m)
      self.totalFlux[1,1] = PTR_NEW(t)
   endif
   if (PTR_VALID(self.ABChopData)) then (*self.ABChopData).DATA1 = $
      (*self.AChopData).DATA1 * (*self.BChopData).DATA1 
   if (PTR_VALID(self.ABChopData)) then (*self.ABChopData).DATA2 = $
      (*self.AChopData).DATA2 * (*self.BChopData).DATA2 
   self.maskFlux[2,0] = PTR_NEW(TOTAL((*self.maskData).DATA1 * SQRT((*self.ABChopData).DATA1>0),2))
   self.maskFlux[2,1] = PTR_NEW(TOTAL((*self.maskData).DATA2 * SQRT((*self.ABChopData).DATA2>0),2))
   self.totalFlux[2,0] = PTR_NEW(TOTAL(SQRT((*self.ABChopData).DATA1 > 0),2))
   self.totalFlux[2,1] = PTR_NEW(TOTAL(SQRT((*self.ABChopData).DATA2 > 0),2))
RETURN
END 

PRO spPhotoChop::photoData, aData=aData, bData=bData, abData=abData, $
   mask=mask, total=total
;********************************************************
;#procedure#
;photoData
;#description#
;return stored photometry data
;#call#
;fringeLabObj->photoData, aData, bData
;#outputs#
;\anArg{aData}{fltarr}{Image of A(source)-A(sky)}
;\anArg{bData}{fltarr}{Image of B(source)-A(sky)}
;\anArg{bData}{fltarr}{aData*bData}
;\anArg{fluxes}{fltarr}{integrated fluxes (*mask) A,B,AB for channels 1,2}
;#end_procedure#
;********************************************************
   if (PTR_VALID(self.AChopData)) then aData = *self.AChopData else RETURN
   if (PTR_VALID(self.BChopData)) then bData = *self.BChopData else RETURN
   if (PTR_VALID(self.ABChopData)) then abData = *self.ABChopData else RETURN
   mask = self.maskFlux
   total = self.totalFlux
RETURN
END

PRO spPhotoChop::resetPhotoMask, maskFile
;
   self.photoMaskFile = maskFile
   PTR_FREE,self.maskData
   if (maskFile NE '') then self.maskData = PTR_NEW(oirGetData(self.photoMaskFile))
RETURN
END

PRO spPhotoChop::maskPlot
   waveLength = 2*!pi/(*self.photoWaveNo)
   plot,waveLength,*self.maskFlux[0,0],yr=[0,1.5*max(*self.maskFlux[0,0])]
   oplot,waveLength,*self.maskFlux[1,0],line=2
   oplot,waveLength,*self.maskFlux[2,0],thick=2
   ll=''
   read,ll
   plot,waveLength,*self.maskFlux[0,1],yr=[0,1.5*max(*self.maskFlux[0,1])]
   oplot,waveLength,*self.maskFlux[1,1],line=2
   oplot,waveLength,*self.maskFlux[2,1],thick=2
RETURN
END

PRO spPhotoChop::totalPlot
   waveLength = 2*!pi/(*self.photoWaveNo)
   plot,waveLength,*self.totalFlux[0,0],yr=[0,1.5*max(*self.totalFlux[0,0])]
   oplot,waveLength,*self.totalFlux[1,0],line=2
   oplot,waveLength,*self.totalFlux[2,0],thick=2
   ll=''
   read,ll
   plot,waveLength,*self.totalFlux[0,1],yr=[0,1.5*max(*self.totalFlux[0,1])]
   oplot,waveLength,*self.totalFlux[1,1],line=2
   oplot,waveLength,*self.totalFlux[2,1],thick=2
RETURN
END

FUNCTION spPhotoChop::waveNo
   RETURN,*self.photoWaveNo
END
