;
; Copyright 2005, 2006 University of Leiden.
;
; This file is part of MIA+EWS.
;
; MIA+EWS is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; MIA+EWS is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with MIA; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
pro calib_sci_disp,pafile,pbfile


if ( N_ELEMENTS(pafile) eq 0) then begin
	print,"usage: calib_sci_disp,'photfileA.fits','photfileB.fits'
        print,"e.g. calib_sci_disp,'/disk-z/mididata/2003-12-11/MIDI.2003-12-12T06:08:55.750.fits','/disk-z/mididata/2003-12-11/MIDI.2003-12-12T06:10:14.750.fits'"
	return
endif
 


chop_sci_disp,pafile
chop_sci_disp,pbfile
spawn,'mkdir  PHOTOMETRY_sciphot'
spawn,'mv PHOTOMETRY/* PHOTOMETRY_sciphot/ ; rm -rf PHOTOMETRY'


chop_int_disp,pafile
chop_int_disp,pbfile
spawn,'mkdir  PHOTOMETRY_I1I2'
spawn,'mv PHOTOMETRY/* PHOTOMETRY_I1I2/ ; rm -rf PHOTOMETRY'


tmp = strsplit(pafile,'/',/extract)
pafile_txt = 'Phot_'+strmid(tmp[n_elements(tmp)-1],5,24)+'txt'
tmp = strsplit(pbfile,'/',/extract)
pbfile_txt = 'Phot_'+strmid(tmp[n_elements(tmp)-1],5,24)+'txt'


sphoto_a = read_ascii('PHOTOMETRY_sciphot/'+pafile_txt,DATA_START=22)
sphot_aa = sphoto_a.field1[*,0:170]
sphoto_a = read_ascii('PHOTOMETRY_sciphot/'+pafile_txt,DATA_START=194)
sphot_ab = sphoto_a.field1[*,0:170]

sphoto_b = read_ascii('PHOTOMETRY_sciphot/'+pbfile_txt,DATA_START=22)
sphot_ba = sphoto_b.field1[*,0:170]
sphoto_b = read_ascii('PHOTOMETRY_sciphot/'+pbfile_txt,DATA_START=194)
sphot_bb = sphoto_b.field1[*,0:170]


iphoto_a = read_ascii('PHOTOMETRY_I1I2/'+pafile_txt,DATA_START=22)
iphot_aa = iphoto_a.field1[*,0:170]
iphoto_a = read_ascii('PHOTOMETRY_I1I2/'+pafile_txt,DATA_START=194)
iphot_ab = iphoto_a.field1[*,0:170]

iphoto_b = read_ascii('PHOTOMETRY_I1I2/'+pbfile_txt,DATA_START=22)
iphot_ba = iphoto_b.field1[*,0:170]
iphoto_b = read_ascii('PHOTOMETRY_I1I2/'+pbfile_txt,DATA_START=194)
iphot_bb = iphoto_b.field1[*,0:170]


ratio_1 = sphot_aa[3,0:168]/iphot_aa[3,1:169]
ratio_2 = sphot_aa[3,0:168]/iphot_ab[3,2:170]
ratio_3 = sphot_bb[3,0:168]/iphot_ba[3,0:168]
ratio_4 = sphot_bb[3,0:168]/iphot_bb[3,1:169]

x = findgen(n_elements(ratio_1))

a = 15

b = 140

c1 = poly_fit(x[a:b],ratio_1[a:b],3)
c2 = poly_fit(x[a:b],ratio_2[a:b],3)
c3 = poly_fit(x[a:b],ratio_3[a:b],3)
c4 = poly_fit(x[a:b],ratio_4[a:b],3)

wdelete,0
wdelete,1

!p.multi=[0, 0, 2, 0, 0]
plot,ratio_1,yrange=[0,2],title="PA/I1"
oplot,poly(x,c1)

plot,ratio_2,yrange=[0,2],title="PA/I2"
oplot,poly(x,c2)

a = ''
read,a

plot,ratio_4,yrange=[0,2],title="PB/I1"
oplot,poly(x,c4)

plot,ratio_3,yrange=[0,2],title="PB/I2"
oplot,poly(x,c3)


print,'coef_pa_i1 = [', c1[0],',',c1[1],',',c1[2],',',c1[3],']'
print,'coef_pa_i2 = [', c2[0],',',c2[1],',',c2[2],',',c2[3],']'
print,'coef_pb_i1 = [', c3[0],',',c3[1],',',c3[2],',',c3[3],']'
print,'coef_pb_i2 = [', c4[0],',',c4[1],',',c4[2],',',c4[3],']'


stop

end
